// Simulation of a simple mixture
//
clc, clear, close             // clear all
[u,t,n]=file();               // find working directory
chdir(dirname(n(1)));         // set working directory

nd=500;                       // number of steps
th=[8 1;0 5]';                // pars of components (in columns)
al=[.2 .8];                   // pars of pointer model

for t=1:nd     // time loop ================================
  c=sum(rand(1,1,'u')>cumsum(al))+1;    // pointer generation
  y=th(:,c)+rand(2,1,'n');              // output
  ct(t)=c;                              // storing
  yt(:,t)=y;                            //   of variables
end  // end of time loop ===================================

// Results
scf(1); plot(yt(1,:),yt(2,:),'.')
title "Simulation with a simple mixture"

save simple.dat ct yt
