function [xx,yy,mt,xr,yr]=meshmesh(dt,m,f,xb,yb)
  // [xx yy mt]=meshmesh(dt,m,f)   accommodating data for mesh plot
  //
  // xx,yy,mt  var. needed for mesh
  // dt        data matric 2 x nd  vars in rows
  // m         number of intervals in axes
  // f         filtration f=0 no filt.  f=1 averaging the neighours

  if nargin<3, f=0; end
  if (nargin<2) | (isempty(m)), m=100; end
  [n nd]=size(dt);
  if n~=2,
    disp ' *** Data matrix must be (2 x nd) ***'
    return
  end
  mi=min(dt');
  ma=max(dt');
  h=(ma-mi)/m;
  xx=mi(1):h(1):ma(1);
  yy=mi(2):h(2):ma(2);
  mt=zeros(m,m); mp=mt;
  for i=1:m
    for j=1:m
      x1=xx(i)<=dt(1,:);
      x2=dt(1,:)<xx(i+1);
      y1=yy(j)<=dt(2,:);
      y2=dt(2,:)<yy(j+1);
      mp(i,j)=sum(x1.*x2.*y1.*y2);
    end
  end

  if f==1
    for i=2:m-2
      for j=2:m-2
        mt(i,j)=(mp(i,j)+mp(i-1,j)+mp(i+1,j)+mp(i,j-1)+mp(i,j+1))/5;
      end
    end
  else
    mt=mp;
  end

  xx=(xx(1:$-1)+xx(2:$))/2;
  yy=(yy(1:$-1)+yy(2:$))/2;

  if nargin>3, 
    if xb(1)<mi(1), xb(1)=mi(1); end
    if xb(2)>ma(1), xb(2)=ma(1); end
    if yb(1)<mi(2), yb(1)=mi(2); end
    if yb(2)>ma(2), yb(2)=ma(2); end
    lgx=ma(1)-mi(1);
    lgy=ma(2)-mi(2);
    xrd=xb(1)-mi(1);
    xrh=xb(2)-mi(1);
    yrd=yb(1)-mi(2);
    yrh=yb(2)-mi(2);
    px=round([xrd/lgx xrh/lgx]*m);
    py=round([yrd/lgy yrh/lgy]*m);
    ix=(px(1)+1):px(2);
    iy=(py(1)+1):py(2);
    //keyboard
    mt=mt(ix,iy);
    xx=xx(ix);
    yy=yy(iy);
  end

  xr=[min(dt(1,:)) max(dt(1,:))];
  yr=[min(dt(2,:)) max(dt(2,:))];
  mt=mt';
endfunction

